#ifndef _SLO2KEYB_H
#define _SLO2KEYB_H

//==========================DOKUMENTACNI CAST=================================

  /*
   * SLO2KEYB.H, verze 1.0
   *
   * Hlavickovy soubor pro modul KEYBOARD.CPP
   * Modul obsahuje rozsirujici fce pro praci s klavesnici
   *
   * Jen pro MS-DOS
   *
   * Martin Slouf, 25.4.1999
   *
   */

//========================DEFINICE SYMBOLICKYCH KONSTANT======================

  /*
   * ktere budou vyuzivany i v jinych modulech
   *
   */

/* konstanty klaves */
#define BACK    8
#define TAB     9
#define ENTER  13
#define ESC    27

#define F1    187
#define F2    188
#define F3    189
#define F4    190
#define F5    191
#define F6    192
#define F7    193
#define F8    194
#define F9    195
#define F10   196
#define F11   261
#define F12   262

#define INS   210
#define DEL   211
#define HOME  199
#define END   207
#define PGUP  201
#define PGDN  209

#define UP    200
#define DOWN  208
#define LEFT  203
#define RIGHT 205

#define POCETFKLAVES 26 /* pocet definovanych funkcnich klaves */

//=======================DEFINICE MAKER S PARAMETRY===========================

  /*
   * ktere budou vyuzivany i v jinych modulech
   *
   */

#define getk(k) (((k = getch()) == '\0') ? (getch() + 128) : k)
  /* pro vyuziti tohoto makra musi byt includovan <conio.h> */

//========================DEFINICE GLOBALNICH TYPU============================

  /*
   * zasadne pomoci typedef
   *
   */

typedef void (*P_FV)(void);
  /* pointer na fci vracejici void - pro procedury obsluhujici polozky menu */
typedef P_FV *P_P_FV;
  /* pointer na pointer na fci vracejici void */
  /* uziva se k definici dynamickeho pole pointeru na fce - tj. nabidky */

//==========DEKLARACE GLOBALNICH PROMENNYCH PRISLUSNEHO .CPP MODULU===========

  /*
   * !!! deklarace, nikoli definice !!!
   *
   * jsou predmetem exportu .CPP modulu - zde uvedeny jako extern deklarace
   *
   */

//===============UPLNE FUNKCNI PROTOTYPY PRISLUSNEHO .CPP MODULU==============

 /*
  * jsou predmetem exportu .CPP modulu - zde uvedeny jako extern deklarace
  *
  */

/* CTENI Z KLAVESNICE */
extern int getkey(void);
  /* vraci znak ze stdin, vcetne funkcnich klaves */
extern int getdefined(const int s[], int *index);
  /* ceka na stisk klavesy, ktera je ulozena v s[]
   * vraci tuto klavesu
   * v promenne index vraci index teto klavesy v poli
   */

/* OBSLUHA STISKU KLAVES */
extern void stisk_TAB(void);
extern void stisk_ESC(void);
extern void stisk_ENTER(void);
extern void stisk_BACK(void);
extern void stisk_F1(void);
extern void stisk_F2(void);
extern void stisk_F3(void);
extern void stisk_F4(void);
extern void stisk_F5(void);
extern void stisk_F6(void);
extern void stisk_F7(void);
extern void stisk_F8(void);
extern void stisk_F9(void);
extern void stisk_F10(void);
extern void stisk_F11(void);
extern void stisk_F12(void);
extern void stisk_INS(void);
extern void stisk_DEL(void);
extern void stisk_HOME(void);
extern void stisk_END(void);
extern void stisk_PGUP(void);
extern void stisk_PGDN(void);
extern void stisk_UP(void);
extern void stisk_DOWN(void);
extern void stisk_LEFT(void);
extern void stisk_RIGHT(void);

#endif