//=========================DOKUMENTACNI CAST==================================

  /*
   * DATA.CPP, verze 1.0
   *
   * Modul k projektu SLO3____.PRJ
   * Poskytuje fce a typy pro praci s daty, se kterymi program pracuje -> DDS
   *
   * Martin Slouf, 22.5.1999
   *
   */

//========================POTREBNE INCLUDE SOUBORY============================

#include <alloc.h>

#include "data.h"

//=================DEFINICE GLOBALNICH EXPORTOVANYCH PROMENNYCH===============

//=======================LOKALNI DEFINICE PRO TENTO MODUL=====================

//========================DEFINICE GLOBALNICH FUNKCI==========================

  /*
   * jde o funkce, ktere jsou exportem modulu, jejich uplne funkcni prototypy
   * jsou v prislusnem .H souboru (obdobne jako u globalnich promennych, ani
   * zde neni uvedena zadna pametova trida, ale v prislusnem .H souboru jsou
   * deklarovany jako extern)
   *
   */

  /*
   * 1. Fce pracujici s frontou slov
   *
   * 2. Fce pracujici s frontou vetnych clenu
   *
   */

  /***********************************
   *                                 *
   * 1. Fce pracujici s frontou slov *
   *                                 *
   ***********************************/

//----------------------VYTVOR_FRONTU_SLOV--------------------------------------
int vytvor_frontu_slov(FRONTASLOV *fs)
  /* vytvori frontu *fs v pameti
   * vraci 1 pri uspechu, pri neuspechu 0 (nedostatek pameti)
   */
{
  if ((fs->p_volny = (P_PFS) malloc(sizeof(PFS))) == NULL)
    return(0);
  else {
    fs->p_celo = fs->p_volny;
    fs->p_volny->p_dalsi = NULL;
    return(1);
  }
}

//----------------------VLOZ_NA_KONEC_FRONTY_SLOV-----------------------------
int vloz_na_konec_fronty_slov(FRONTASLOV *fs, P_SLOVO p_s)
  /* na konec fronty (do prvku volny) vlozi hodnotu p_s
   * vraci 1, je-li operace uspesne provedena
   */
{
  fs->p_volny->slovo = *p_s;
  if ((fs->p_volny->p_dalsi = (P_PFS) malloc(sizeof(PFS))) == NULL)
    return(0);
  else {
    fs->p_volny = fs->p_volny->p_dalsi;
    fs->p_volny->p_dalsi = NULL;
    return(1);
  }
}

//----------------------ODEBER_CELO_FRONTY_SLOV-------------------------------
int odeber_celo_fronty_slov(FRONTASLOV *fs, SLOVO *s)
  /* odebere prvni prvek fronty (prvek, kam ukazuje celo)
   * vraci 1, je-li vse Ok
   */
{
  if (je_fronta_slov_prazdna(*fs))
    return(0);
  else {
    P_PFS p_pfs;

    p_pfs = fs->p_celo;
    fs->p_celo = fs->p_celo->p_dalsi;
    *s = p_pfs->slovo;
    free(p_pfs);
    return(1);
  }
}

//----------------------UVOLNI_FRONTU_SLOV------------------------------------
void uvolni_frontu_slov(FRONTASLOV *fs)
  /* uvolni pamet alokovanou frontou slov fs */
{
  SLOVO s;

  /* uvolneni pouzivane pameti */
  while (!je_fronta_slov_prazdna(*fs))
    odeber_celo_fronty_slov(fs, &s);

  /* uvolneni volneho (posledniho) prvku */
  free(fs->p_volny);
}

//---------------------------GET_PRVEK_NA_POZICI------------------------------
P_PFS get_prvek_z_fs_s_poradim(FRONTASLOV *fs, int poradi)
{
  P_PFS p_pfs;

  for (p_pfs = fs->p_celo; (p_pfs->slovo.poradi != poradi && p_pfs != fs->p_volny); p_pfs = p_pfs->p_dalsi)
    ;

  return(p_pfs);
}

  /********************************************
   *                                          *
   * 2. Fce pracujici s frontou vetnych clenu *
   *                                          *
   ********************************************/

//----------------------VYTVOR_FRONTU_VC--------------------------------------
int vytvor_frontu_vc(FRONTAVETNYCHCLENU *fvc)
  /* vytvori frontu *fvc v pameti
   * vraci 1, pokud je to Ok, 0 pri nedostatku pameti
   */
{
  if ((fvc->p_volny = (P_PFVC) malloc(sizeof(PFVC))) == NULL)
    return(0);
  else {
    fvc->p_celo = fvc->p_volny;
    fvc->p_volny->p_dalsi = NULL;
    return(1);
  }
}

//----------------------VLOZ_NA_KONEC_FRONTY_VC-------------------------------
int vloz_na_konec_fronty_vc(FRONTAVETNYCHCLENU *fvc, P_VETNYCLEN p_vc)
  /* na konec fronty (do prvku volny) vlozi hodnotu p_vc
   * vraci 1, je-li operace uspesne provedena
   */
{
  fvc->p_volny->vetnyclen = *p_vc;
  if ((fvc->p_volny->p_dalsi = (P_PFVC) malloc(sizeof(PFVC))) == NULL)
    return(0);
  else {
    fvc->p_volny = fvc->p_volny->p_dalsi;
    fvc->p_volny->p_dalsi = NULL;
    return(1);
  }
}

//----------------------ODEBER_CELO_FRONTY_VC---------------------------------
int odeber_celo_fronty_vc(FRONTAVETNYCHCLENU *fvc, VETNYCLEN *vc)
  /* odebere prvni prvek fronty (prvek, kam ukazuje celo)
   * vraci 1, je-li vse Ok
   */
{
  if (je_fronta_vc_prazdna(*fvc)) {
    return(0);
  }
  else {
    P_PFVC p_pfvc;

    p_pfvc = fvc->p_celo;
    fvc->p_celo = fvc->p_celo->p_dalsi;
    *vc = p_pfvc->vetnyclen;
    free(p_pfvc);
    return(1);
  }
}

//----------------------UVOLNI_FRONTU_VC--------------------------------------
void uvolni_frontu_vc(FRONTAVETNYCHCLENU *fvc)
  /* uvolni pamet alokovanou frontou slov fvc */
{
  VETNYCLEN vc;

  /* uvolneni pouzivane pameti */
  while (!je_fronta_vc_prazdna(*fvc))
    odeber_celo_fronty_vc(fvc, &vc);

  /* uvolneni volneho (posledniho) prvku */
  free(fvc->p_volny);
}

//========================DEFINICE LOKALNICH FUNKCI===========================

  /*
   * definice funkci pro tento modul (pametova trida static)
   *
   * jejich funkcni prototypy - viz vyse
   *
   */