//=========================DOKUMENTACNI CAST==================================

  /*
   * HLAVNI.CPP, verze 1.0
   *
   * Hlavni modul projektu SLO3____.PRJ. Slouyi k analyze formalnich vetnych
   * vztahu
   *
   * Martin Slouf, 22.4.1999
   *
   */

//========================POTREBNE INCLUDE SOUBORY============================

  /*
   * systemove .H soubory #include <stdio.h>
   *
   * vlastni .H soubory #include "vzor.h"
   *
   */

#include <stdio.h>
#include <conio.h>
#include <string.h>

#include "myvision.h"
#include "data.h"

//===================DEFINICE GLOBALNICH IMPORTOVANYCH OBJEKTU================

  //zadne by byt nemely - vse by melo byt v .H souborech

  /*
   * jde o importovane objekty (fce nebo promenne) - jiz musi byt v nejakem
   * modulu definovany (v casti globalnich definic)
   *
   * zde se objevi jako extern deklarace
   *
   */


//=================DEFINICE GLOBALNICH EXPORTOVANYCH PROMENNYCH===============

  /*
   * jde o globalni promenne, ktere maji byt sdileny s jinymi moduly, zde
   * nejsou definovany jako extern - jde o jejich "domaci" modul
   *
   * ve sdilenych modulech se objevi za pomoci .H souboru prislusejiciho
   * k tomuto modulu (v tomto .H souboru budou uvedeny jako extern deklarace)
   *
   */

//=======================LOKALNI DEFINICE PRO TENTO MODUL=====================

  /*
   * lokalni definice pouze pro tento modul (soubor), pokud by tyto definice
   * byly prilis rozsahle -> specialni .H soubor
   *
   */

  /*
   * 1. symbolicke konstanty a makra s parametry
   *
   */

  /*
   * 2. typy - zasadne pomoci typedef
   *
   */

  /*
   * 3. promenne - jde o globalni promenne pro tento modul - v pametove tride
   *    static
   *
   */

  /*
   * 4. uplne funkcni prototypy lokalnich (=pro tento modul) funkci, tj.
   * v pametove tride static
   *
   */

/* 1. PRACE S FRONTOU SLOV -> TJ. VETOU */

/* 1a. zakladni fce */
int nacti_frontu_slov(FRONTASLOV *fs, int limit);
  /* vraci 1, je-li vse v poradku
   * do fs nacte slova zadavana z klavesnice omezena delkou limit
   * limit = standartne MAXDELKASLOVA = 20 znaku
   */
void nacti_potrebne_udaje_o_slovech(FRONTASLOV *fs);
void vypis_vlastnosti_slova(P_SLOVO p_s);
  /* vypisuje u slova *p_s vsechny udaje */

/* 1b. fce nabidek pro urcovani slovniho druhu */
void sd_podj(void *arg);
void sd_pridj(void *arg);
void sd_zajmeno(void *arg);
void sd_cislovka(void *arg);
void sd_sloveso(void *arg);
void sd_prislovce(void *arg);
void sd_predlozka(void *arg);
void sd_spojka(void *arg);
void sd_castice(void *arg);
void sd_citoslovce(void *arg);

/* 1c. fce nabidek urceni vlastnosti jmen */
void nacti_vlastnosti_jmena(void *arg);
/* nasledujici fce se pouzivaji i pri volani nabidek v menu urceni vlastnosti
 * predlozek
 */
void p_nominativ(void *arg); /* p = pad */
void p_genitiv(void *arg);
void p_dativ(void *arg);
void p_akuzativ(void *arg);
void p_vokativ(void *arg);
void p_lokal(void *arg);
void p_instrumental(void *arg);
/* nasledujici fce se pouzivaji i pri volani nabidek v menu urceni vlastnosti
 * sloves
 */
void rj_masculinum(void *arg); /* rj = rod jmena */
void rj_feminimum(void *arg);
void rj_neutrum(void *arg);
void rj_neznamy(void *arg); /* jen u slovesa */
void c_singular(void *arg); /* c = cislo */
void c_plural(void *arg);

/* 1d. fce nabidek urceni vlastnosti sloves */
void nacti_vlastnosti_slovesa(void *arg);
void ts_urcity(void *arg);
void ts_neurcity_pricesti(void *arg);
void ts_neurcity_infinitiv(void *arg);
void os_prvni(void *arg); /* os = osoba slovesa */
void os_druha(void *arg);
void os_treti(void *arg);

/* 1e. fce nabidek urceni vlastnosti predlozek */
void nacti_vlastnosti_predlozky(void *arg);
void pp_poji_se(void *arg); /* s jakym padem se predlozka poji */

/* 2. PRACE S VETNYMI CLENY -> TJ.STRUKTUROU VETY */
void nacti_frontu_vetnych_clenu(FRONTAVETNYCHCLENU *fvc, FRONTASLOV *fs, int limit);
  /* do fvc nacte vetne cleny z fronty slov fs
   * delka vetneho clenu je omezena paramtrem limit, standartne limit =
   * = MAXDELKAVETNEHOCLENU = 40
   */
void vypis_vlastnosti_vc(P_VETNYCLEN p_vc);
  /* vypisuje vsechny udaje o vetnem clenu *p_vc */

  /* 3. ANALYZA VZTAHU MEZI VETNYMI CLENY */

int analyzuj_vztahy_mezi_vetnymi_cleny(FRONTAVETNYCHCLENU *fvc, FRONTASLOV *fs);
  /* vraci 1, je-li vse OK
   * vraci nula, jestlize se mu nepodarilo urcit vsechny vztahy
   * vraci -1, nastala-li nejaka zasadni chyba (chybi podmet, prisudekm, ...
   * urcuje nadrizenost a podrizenost
   * predpoklada. ze vsechny vetne cleny jsou jiz urceny
   */

P_PFVC hledej_prisudek(FRONTAVETNYCHCLENU *fvc, FRONTASLOV *fs, P_PFVC od_pozice);
  /* vraci pointer na prisudek, jinak NULL
   * prohledava fvc od pozice ukazatele od_pozice - na zacatku celo, potom
   * tma poslu vzdy od pozice neuspesneho nalezu
   */
P_PFVC hledej_podmet(FRONTAVETNYCHCLENU *fvc, FRONTASLOV *fs, P_PFVC od_pozice, P_PFVC prisudek);
  /* vraci pointer na podmet, jinak NULL
   * prohledava fvc od pozice ukazatele od_pozice - na zacatku celo, potom
   * tma poslu vzdy od pozice neuspesneho nalezu
   */

  /*
   * 5. fce main - pokud jde o hlavni soubor projektu
   *
   */

//---------------------------------MAIN---------------------------------------
int main(void)
{
  FRONTASLOV veta;
  FRONTAVETNYCHCLENU struktura_vety;

  clrscr();
  textmode(C4350);

  if (vytvor_frontu_slov(&veta) == 0 || vytvor_frontu_vc(&struktura_vety) == 0) {
    printf("\nERROR: malo pameti\n");
  }
  else if (nacti_frontu_slov(&veta, MAXDELKASLOVA) == 0 || je_fronta_slov_prazdna(veta)) {
    printf("\nERROR: nebyla nactena veta!\n");

    /* uvolneni alokovane pameti v pripade chyby u nacteni vety*/
    uvolni_frontu_slov(&veta);
    uvolni_frontu_vc(&struktura_vety);
  }
  else {
    /* doplneni potrebnych udaju */
    nacti_potrebne_udaje_o_slovech(&veta);
    (void) getkey();

    /* urceni vetnych clenu */
    clrscr();
    nacti_frontu_vetnych_clenu(&struktura_vety, &veta, MAXDELKAVETNEHOCLENU);
    (void) analyzuj_vztahy_mezi_vetnymi_cleny(&struktura_vety, &veta);

    /* uvolneni alokovane pameti po zdarnem ukonceni programu*/
    uvolni_frontu_slov(&veta);
    uvolni_frontu_vc(&struktura_vety);
  }

  textmode(C80);
  clrscr();
  return(0);
}

//========================DEFINICE GLOBALNICH FUNKCI==========================

  /*
   * jde o funkce, ktere jsou exportem modulu, jejich uplne funkcni prototypy
   * jsou v prislusnem .H souboru (obdobne jako u globalnich promennych, ani
   * zde neni uvedena zadna pametova trida, ale v prislusnem .H souboru jsou
   * deklarovany jako extern)
   *
   */

//========================DEFINICE LOKALNICH FUNKCI===========================

  /*
   * definice funkci pro tento modul (pametova trida static)
   *
   * jejich funkcni prototypy - viz vyse
   *
   */

  /*
   * 1. Prace se slovy - nacteni a doplneni udaju
   *
   *    a) zakladni fce
   *
   *    b) fce nabidky urceni slovniho druhu a prislusnych vlastnosti
   *
   *    c) fce nabidek urceni vlastnosti jmen
   *
   *    d) fce nabidek urceni vlastnosti sloves
   *
   *    e) fce nabidek urceni vlastnosti predlozek
   *
   * 2. Prace s vetnymi cleny - vytvoreni fronty vetnych clenu
   *
   * 3. Analyza vztahu mezi vetnymi cleny
   *
   */

  /***********************************************
   *                                             *
   * 1a. zakladni fce - nacteni a doplneni udaju *
   *                                             *
   ***********************************************/

//-------------------------NACTI_FRONTU_SLOV----------------------------------
int nacti_frontu_slov(FRONTASLOV *fs, int limit)
  /* vraci 1, je/li nacteni vety a jeji ulozeni do fronty v poradku
   * vraci 0 pri jakekkoli chybe (malo pameti, spatne zadani, ...)
   * limit urcuje maxdelku slova - viz take symbolicka konstanta MAXDELKASLOVA
   */
{
  int c; /* znak do ktereho ctu */
  int i = 0; /* oznacuje volnou pozici pro nacitany string (tj. slovo) */
  BOOLEAN jsem_ve_slove = NE;
  SLOVO s; /* do tohoto slova provadim nacitani */

  printf("Zadej vetu a ukonci TECKOU ( . ) !\n");

  /* nacitani vety po slovech */
  while ((c = getchar()) != '\n') {

    if (c == ' ' || c == '\t' || c == '.')
      jsem_ve_slove = NE;
    else {
      if (i < (limit - 1))
        s.jmenovka[i++] = (char) c;
      if (jsem_ve_slove == NE)
        jsem_ve_slove = ANO;
    }

    /* ulozeni slova do fronty */
    if (jsem_ve_slove == NE && i > 0) {
      s.jmenovka[i] = '\0';
      vloz_na_konec_fronty_slov(fs, &s);
      i = 0;
      s.jmenovka[0] = '\0';
    } /* konec if */

  } /* konec while */
  return(1);
}

//------------------------VYPIS_VLASTNOSTI_SLOVA------------------------------
void vypis_vlastnosti_slova(P_SLOVO p_s)
{
  printf("poradi: %d\n"
	 "druh: %d\n"
         "typ_vetneho_clenu: %d \n"
         "vlastnosti.pad: %d\n"
         "vlastnosti.rod: %d\n"
         "vlastnosti.cislo_jmena: %d\n"
         "vlastnosti.tvar: %d\n"
         "vlastnosti.osoba: %d\n"
	 "vlastnosti.cislo_slovesa: %d\n"
         "vlastnosti.jmenny_rod: %d\n"
         "vlastnosti.predlozka: %d\n",
         p_s->poradi,
         p_s->druh,
         p_s->typ_vetneho_clenu,
         p_s->vlastnosti.pad,
         p_s->vlastnosti.rod,
         p_s->vlastnosti.cislo_jmena,
         p_s->vlastnosti.tvar,
         p_s->vlastnosti.osoba,
         p_s->vlastnosti.cislo_slovesa,
         p_s->vlastnosti.jmenny_rod,
         p_s->vlastnosti.predlozka);
}

//------------------------NACTI_POTREBNE_UDAJE_O_SLOVECH----------------------
void nacti_potrebne_udaje_o_slovech(FRONTASLOV *fs)
  /* 1. vraci 1, probehlo-li doplneni  *fs v poradku, jinak 0
   * 2. pracuje s nabidkami
   * 3. prochazi slovo po slove a u kazdeho zada o doplneni udaju, zatim
   *    neurcene nastavuje na neutralni nebo prazdne hodnoty
   * 4. nacita jen to, co zada uzivatel -> viz tez fce
   *    dopln_potrebne_udaje_o_vete()
   */
{
  int i;
  P_SLOVO p_s;
  P_PFS p_pfs; /* pointer na prvek fronty slov */
  /* nabidka pro urceni druhu slova */
  MENU urceni_slovniho_druhu = {
                                 {"[1] PODJ",
                                  "[2] PRIDJ",
                                  "[3] ZAJMENO",
                                  "[4] CISLOVKA",
				  "[5] SLOVESO",
                                  "[6] PRISLOVCE",
                                  "[7] PREDLOZKA",
                                  "[8] SPOJKA",
                                  "[9] CASTICE",
                                  "[0] CITOSLOVCE",
                                  ""} ,
                                 {sd_podj, sd_pridj, sd_zajmeno, sd_cislovka,
                                  sd_sloveso, sd_prislovce, sd_predlozka,
                                  sd_spojka, sd_castice, sd_citoslovce,
                                  NULL} ,
                                 {'1', '2', '3', '4', '5', '6', '7', '8', '9',
                                  '0',
                                  '\0'}
                               };
  P_MENU p_urceni_slovniho_druhu = &urceni_slovniho_druhu;

  for (i = 0, p_pfs = fs->p_celo; p_pfs != fs->p_volny; p_pfs = p_pfs->p_dalsi, ++i) {
    p_s = &p_pfs->slovo;
    p_s->poradi = (i + 1);
    printf("\n--------  %d. Slovo:  %s  --------\n\n", p_s->poradi, p_s->jmenovka);
    vypis_menu(p_urceni_slovniho_druhu);
    zpracuj_menu(p_urceni_slovniho_druhu, p_s);
  }

  /* oprava typu vetnych clenu
   * (zvratna) zajmena 'se', 'si': SAMOSTATNY -> NESAMOSTATNY
   * slozene slovesne tvary (spony + pomocna slovesa + modalni slovesa + casy)
   */

  /* zajmena 'se' a 'si' */
  for (i = 0, p_pfs = fs->p_celo; p_pfs != fs->p_volny; p_pfs = p_pfs->p_dalsi, ++i) {
    if (p_pfs->slovo.druh == ZAJMENO) {
      if (strcmp(p_pfs->slovo.jmenovka, "se") == 0 || strcmp(p_pfs->slovo.jmenovka, "si") == 0) {
        p_pfs->slovo.typ_vetneho_clenu = NESAMOSTATNY;
	printf("\nU zvratneho zajmena (%d. slovo v poradi, jmenovka: %s) zmenen typ vetneho clenu na NESAMOSTATNY.\n",
               p_pfs->slovo.poradi, p_pfs->slovo.jmenovka);
      }
    }
  }

  /* uprav slozenych tvaru sloves
   * oprava probehne:
   *   a) u neurciteho tvaru - pricesti
   *   b) u neurciteho tvaru - infinitivu
   *   c) u urciteho tvaru
   */

}

  /*****************************************
   *                                       *
   * 1b. fce nabidek urceni slovniho druhu *
   *                                       *
   *****************************************/

//---------------------SD_PODJ------------------------------------------------
void sd_podj(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = PODJ;
  ((P_SLOVO) arg)->typ_vetneho_clenu = SAMOSTATNY;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  nacti_vlastnosti_jmena(arg);

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

//---------------------SD_PRIDJ-----------------------------------------------
void sd_pridj(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = PRIDJ;
  ((P_SLOVO) arg)->typ_vetneho_clenu = SAMOSTATNY;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  nacti_vlastnosti_jmena(arg);

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

//---------------------SD_ZAJMENO---------------------------------------------
void sd_zajmeno(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = ZAJMENO;
  ((P_SLOVO) arg)->typ_vetneho_clenu = SAMOSTATNY;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  nacti_vlastnosti_jmena(arg);

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

//---------------------SD_CISLOVKA--------------------------------------------
void sd_cislovka(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = CISLOVKA;
  ((P_SLOVO) arg)->typ_vetneho_clenu = SAMOSTATNY;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  nacti_vlastnosti_jmena(arg);

  /* tisk nastavenych vlastnosti */
 vypis_vlastnosti_slova((P_SLOVO) arg);
}

//--------------------SD_SLOVESO----------------------------------------------
void sd_sloveso(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = SLOVESO;
  ((P_SLOVO) arg)->typ_vetneho_clenu = SAMOSTATNY;
    /* tady se rozhoduji o typu vetneho clenu az ve druhem kroku prozatimni
     * nastaveni - SAMOSTATNY
     * viz konec fce nacti_potrebne_udaje_o_slovech (cast 1a.)
     */

  /* nastaveni specifickych vlastnosti slovniho druhu */
  nacti_vlastnosti_slovesa(arg);

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

//--------------------SD_PRISLOVCE--------------------------------------------
void sd_prislovce(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = PRISLOVCE;
  ((P_SLOVO) arg)->typ_vetneho_clenu = SAMOSTATNY;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  ((P_SLOVO) arg)->vlastnosti.pad = PADSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_jmena = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.tvar = TVARSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.osoba = OSOBASENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.jmenny_rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.predlozka = PADSENEPOUZIVA;

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

//--------------------SD_PREDLOZKA--------------------------------------------
void sd_predlozka(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = PREDLOZKA;
  ((P_SLOVO) arg)->typ_vetneho_clenu = NESAMOSTATNY;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  nacti_vlastnosti_predlozky(arg);

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

//--------------------SD_SPOJKA-----------------------------------------------
void sd_spojka(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = SPOJKA;
  ((P_SLOVO) arg)->typ_vetneho_clenu = NENI;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  ((P_SLOVO) arg)->vlastnosti.pad = PADSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_jmena = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.tvar = TVARSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.osoba = OSOBASENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.jmenny_rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.predlozka = PADSENEPOUZIVA;

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

//--------------------SD_CASTICE----------------------------------------------
void sd_castice(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = CASTICE;
  ((P_SLOVO) arg)->typ_vetneho_clenu = NENI;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  ((P_SLOVO) arg)->vlastnosti.pad = PADSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_jmena = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.tvar = TVARSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.osoba = OSOBASENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.jmenny_rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.predlozka = PADSENEPOUZIVA;

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

//--------------------SD_CITOSLOVCE-------------------------------------------
void sd_citoslovce(void *arg)
{
  /* nastaveni obecnych vlastnosti slova */
  ((P_SLOVO) arg)->druh = CITOSLOVCE;
  ((P_SLOVO) arg)->typ_vetneho_clenu = SAMOSTATNY;

  /* nastaveni specifickych vlastnosti slovniho druhu */
  ((P_SLOVO) arg)->vlastnosti.pad = PADSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_jmena = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.tvar = TVARSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.osoba = OSOBASENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.jmenny_rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.predlozka = PADSENEPOUZIVA;

  /* tisk nastavenych vlastnosti */
  vypis_vlastnosti_slova((P_SLOVO) arg);
}

  /******************************************
   *                                        *
   * 1c. fce nabidek urceni vlastnosti jmen *
   *                                        *
   ******************************************/

//---------------------NACTI_VLASTNOSTI_JMENA---------------------------------
void nacti_vlastnosti_jmena(void *arg)
{
  MENU urceni_padu_jmena = {
			     {"[1] NOMINATIV",
                              "[2] GENITIV",
                              "[3] DATIV",
                              "[4] AKUZATIV",
                              "[5] VOKATIV",
                              "[6] LOKAL",
                              "[7] INSTRUMENTAL",
			      ""} ,
                             {p_nominativ, p_genitiv, p_dativ, p_akuzativ,
                              p_vokativ, p_lokal, p_instrumental,
                              NULL} ,
                             {'1', '2', '3', '4', '5', '6', '7',
                              '\0'}
                           };
  P_MENU p_urceni_padu_jmena = &urceni_padu_jmena;

  MENU urceni_rodu_jmena = {
                             {"[1] MASCULINUM",
                              "[2] FEMINIMUM",
                              "[3] NEUTRUM",
                              ""} ,
                             {rj_masculinum, rj_feminimum, rj_neutrum,
                              NULL} ,
                             {'1', '2', '3',
                              '\0'}
                           };
  P_MENU p_urceni_rodu_jmena = &urceni_rodu_jmena;

  MENU urceni_cisla_jmena = {
                              {"[1] SINGULAR",
                               "[2] PLURAL",
                               ""} ,
                              {c_singular, c_plural,
                               NULL} ,
                              {'1', '2',
			       '\0'}
                            };
  P_MENU p_urceni_cisla_jmena = &urceni_cisla_jmena;

  /* nastaveni vlastnosti nepouzivanych vlastnosti */
  ((P_SLOVO) arg)->vlastnosti.tvar = TVARSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.osoba = OSOBASENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.jmenny_rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.predlozka = PADSENEPOUZIVA;

  /* nastaveni specifickych vlastnosti vlastnosti */
  printf("Urceni padu jmena\n\n");
  vypis_menu(p_urceni_padu_jmena);
  zpracuj_menu(p_urceni_padu_jmena, arg);

  printf("Urceni rodu jmena\n\n");
  vypis_menu(p_urceni_rodu_jmena);
  zpracuj_menu(p_urceni_rodu_jmena, arg);

  printf("Urceni cisla jmena\n\n");
  vypis_menu(p_urceni_cisla_jmena);
  zpracuj_menu(p_urceni_cisla_jmena, arg);
}

//----------------------------P_NOMINATIV-------------------------------------
void p_nominativ(void *arg)
{
  /* mam zaruceno, ze slovni druh je urcen */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.pad = NOMINATIV;
    break;

    case PREDLOZKA:
      ((P_SLOVO) arg)->vlastnosti.predlozka = NOMINATIV;
    break;

    default:
      ;
    break;
  }
}

//----------------------------P_GENITIV---------------------------------------
void p_genitiv(void *arg)
{
  /* mam zaruceno, ze slovni druh je urcen */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.pad = GENITIV;
    break;

    case PREDLOZKA:
      ((P_SLOVO) arg)->vlastnosti.predlozka = GENITIV;
    break;

    default:
      ;
    break;
  }
}

//----------------------------P_DATIV-----------------------------------------
void p_dativ(void *arg)
{
  /* mam zaruceno, ze slovni druh je urcen */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.pad = DATIV;
    break;

    case PREDLOZKA:
      ((P_SLOVO) arg)->vlastnosti.predlozka = DATIV;
    break;

    default:
      ;
    break;
  }
}

//----------------------------P_AKUZATIV--------------------------------------
void p_akuzativ(void *arg)
{
  /* mam zaruceno, ze slovni druh je urcen */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.pad = AKUZATIV;
    break;

    case PREDLOZKA:
      ((P_SLOVO) arg)->vlastnosti.predlozka = AKUZATIV;
    break;

    default:
      ;
    break;
  }
}

//----------------------------P_VOKATIV---------------------------------------
void p_vokativ(void *arg)
{
  /* mam zaruceno, ze slovni druh je urcen */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.pad = VOKATIV;
    break;

    case PREDLOZKA:
      ((P_SLOVO) arg)->vlastnosti.predlozka = VOKATIV;
    break;

    default:
      ;
    break;
  }
}

//----------------------------P_LOKAL-----------------------------------------
void p_lokal(void *arg)
{
  /* mam zaruceno, ze slovni druh je urcen */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.pad = LOKAL;
    break;

    case PREDLOZKA:
      ((P_SLOVO) arg)->vlastnosti.predlozka = LOKAL;
    break;

    default:
      ;
    break;
  }
}

//----------------------------P_INSTRUMENTAL----------------------------------
void p_instrumental(void *arg)
{
  /* mam zaruceno, ze slovni druh je urcen */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.pad = INSTRUMENTAL;
    break;

    case PREDLOZKA:
      ((P_SLOVO) arg)->vlastnosti.predlozka = INSTRUMENTAL;
    break;

    default:
      ;
    break;
  }
}

//---------------------------RJ_MASCULINUM------------------------------------
void rj_masculinum(void *arg)
{
  /* mam zajisteno, ze pri volani bude hodnota slovniho druhu naplnena */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.rod = M;
    break;

    case SLOVESO:
      ((P_SLOVO) arg)->vlastnosti.jmenny_rod = M;
    break;

    default:
      ;
    break;
  }
}

//---------------------------RJ_FEMINIMUM-------------------------------------
void rj_feminimum(void *arg)
{
  /* mam zajisteno, ze pri volani bude hodnota slovniho druhu naplnena */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.rod = F;
    break;

    case SLOVESO:
      ((P_SLOVO) arg)->vlastnosti.jmenny_rod = F;
    break;

    default:
      ;
    break;
  }
}

//---------------------------RJ_NEUTRUM---------------------------------------
void rj_neutrum(void *arg)
{
  /* mam zajisteno, ze pri volani bude hodnota slovniho druhu naplnena */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.rod = N;
    break;

    case SLOVESO:
      ((P_SLOVO) arg)->vlastnosti.jmenny_rod = N;
    break;

    default:
      ;
    break;
  }
}

//----------------------------RJ_NEZNAMY--------------------------------------
void rj_neznamy(void *arg)
  /* ! volana jen u slovesa ! */
{
  ((P_SLOVO) arg)->vlastnosti.jmenny_rod = RODSENEPOUZIVA;
}

//----------------------------C_SINGULAR--------------------------------------
void c_singular(void *arg)
{
  /* mam zajisteno, ze pri volani bude hodnota slovniho druhu naplnena */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.cislo_jmena = SG;
    break;

    case SLOVESO:
      ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = SG;
    break;

    default:
      ;
    break;
  }
}

//----------------------------C_PLURAL----------------------------------------
void c_plural(void *arg)
{
  /* mam zajisteno, ze pri volani bude hodnota slovniho druhu naplnena */
  switch (((P_SLOVO) arg)->druh) {

    case PODJ:

    case PRIDJ:

    case ZAJMENO:

    case CISLOVKA:
      ((P_SLOVO) arg)->vlastnosti.cislo_jmena = PL;
    break;

    case SLOVESO:
      ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = PL;
    break;

    default:
      ;
    break;
  }
}

  /********************************************
   *                                          *
   * 1d. fce nabidek urceni vlastnosti sloves *
   *                                          *
   ********************************************/

//--------------------------NACTI_VLASTNOSTI_SLOVESA--------------------------
void nacti_vlastnosti_slovesa(void *arg)
{
  MENU urceni_tvaru_slovesa = {
                                {"[1] URCITY",
                                 "[2] NEURCITY - PRICETSI",
                                 "[3] NEURCITY - INFINITIV",
                                 ""} ,
                                {ts_urcity, ts_neurcity_pricesti,
				 ts_neurcity_infinitiv,
                                 NULL} ,
                                {'1', '2', '3',
                                 '\0'}
                              };
  P_MENU p_urceni_tvaru_slovesa = &urceni_tvaru_slovesa;

  /* nastaveni nepouzivanych vlastnosti - zbyle se donastavuji podle tvaru */
  ((P_SLOVO) arg)->vlastnosti.pad = PADSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_jmena = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.predlozka = PADSENEPOUZIVA;

  /* nastaveni specifickych vlastnosti */
  printf("Urceni tvaru slovesa\n\n");
  vypis_menu(p_urceni_tvaru_slovesa);
  zpracuj_menu(p_urceni_tvaru_slovesa, arg);
}

//-----------------------------TS_URCITY--------------------------------------
void ts_urcity(void *arg)
{
  MENU urceni_osoby_slovesa = {
                                {"[1] PRVNI",
                                 "[2] DRUHA",
                                 "[3] TRETI",
                                 ""} ,
                                {os_prvni, os_druha, os_treti,
				 NULL} ,
                                {'1', '2', '3',
                                 '\0'}
                              };
  P_MENU p_urceni_osoby_slovesa = &urceni_osoby_slovesa;

  MENU urceni_cisla_slovesa = {
				{"[1] SINGULAR",
                                 "[2] PLURAL",
                                 ""} ,
                                {c_singular, c_plural,
                                 NULL} ,
                                {'1', '2',
                                 '\0'}
                              };
  P_MENU p_urceni_cisla_slovesa = &urceni_cisla_slovesa;

  MENU urceni_jmenneho_rodu = {
                                {"[1] MASCULINUM",
                                 "[2] FEMINIMUM",
                                 "[3] NEUTRUM",
                                 "[4] NELZE URCIT",
                                 ""} ,
                                {rj_masculinum, rj_feminimum, rj_neutrum,
                                 rj_neznamy /* ! jen u slovesa ! */,
                                 NULL} ,
                                {'1', '2', '3', '4',
                                 '\0'}
                              };
  P_MENU p_urceni_jmenneho_rodu = &urceni_jmenneho_rodu;

  /* nastaveni nepouzivanych vlastnosti */
  /* nejsou */

  /* nastaveni specifickych vlastnosti */
  ((P_SLOVO) arg)->vlastnosti.tvar = URCITY;

  printf("Urceni osoby slovesa\n\n");
  vypis_menu(p_urceni_osoby_slovesa);
  zpracuj_menu(p_urceni_osoby_slovesa, arg);

  printf("Urceni cisla slovesa\n\n");
  vypis_menu(p_urceni_cisla_slovesa);
  zpracuj_menu(p_urceni_cisla_slovesa, arg);

  printf("Urceni jmenneho rodu\n\n");
  vypis_menu(p_urceni_jmenneho_rodu);
  zpracuj_menu(p_urceni_jmenneho_rodu, arg);

}

//------------------------------TS_NEURCITY_PRICETSI--------------------------
void ts_neurcity_pricesti(void *arg)
{
  MENU urceni_cisla_slovesa = {
                                {"[1] SINGULAR",
                                 "[2] PLURAL",
                                 ""} ,
                                {c_singular, c_plural,
                                 NULL} ,
                                {'1', '2',
                                 '\0'}
                              };
  P_MENU p_urceni_cisla_slovesa = &urceni_cisla_slovesa;

  MENU urceni_jmenneho_rodu = {
                                {"[1] MASCULINUM",
                                 "[2] FEMINIMUM",
                                 "[3] NEUTRUM",
                                 "[4] NEZNAMY",
				 ""} ,
                                {rj_masculinum, rj_feminimum, rj_neutrum,
                                 rj_neznamy /* ! jen u slovesa ! */,
                                 NULL} ,
                                {'1', '2', '3', '4',
                                 '\0'}
                              };
  P_MENU p_urceni_jmenneho_rodu = &urceni_jmenneho_rodu;

  /* nastaveni nepouzivanych vlastnosti */
  ((P_SLOVO) arg)->vlastnosti.osoba = OSOBASENEPOUZIVA;

  /* nastaveni specifickych vlastnosti */
  ((P_SLOVO) arg)->vlastnosti.tvar = NEURCITY_PRICESTI;

  printf("Urceni cisla slovesa\n\n");
  vypis_menu(p_urceni_cisla_slovesa);
  zpracuj_menu(p_urceni_cisla_slovesa, arg);

  printf("Urceni jmenneho rodu\n\n");
  vypis_menu(p_urceni_jmenneho_rodu);
  zpracuj_menu(p_urceni_jmenneho_rodu, arg);
}

//------------------------------TS_NEURCITY_INFINITIV-------------------------
void ts_neurcity_infinitiv(void *arg)
{
  /* nastaveni nepouzivanych vlastnosti */
  ((P_SLOVO) arg)->vlastnosti.osoba = OSOBASENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.jmenny_rod = RODSENEPOUZIVA;

  /* nastaveni specifickych vlastnosti */
  ((P_SLOVO) arg)->vlastnosti.tvar = NEURCITY_INFINITIV;
}

//-------------------------------OS_PRVNI-------------------------------------
void os_prvni(void *arg)
{
  ((P_SLOVO) arg)->vlastnosti.osoba = PRVNI;
}

//-------------------------------OS_DRUHA-------------------------------------
void os_druha(void *arg)
{
  ((P_SLOVO) arg)->vlastnosti.osoba = DRUHA;
}

//---------------------------------OS_TRETI-----------------------------------
void os_treti(void *arg)
{
  ((P_SLOVO) arg)->vlastnosti.osoba = TRETI;
}

  /***********************************************
   *                                             *
   * 1e. fce nabidek urceni vlastnosti predlozek *
   *                                             *
   ***********************************************/

void nacti_vlastnosti_predlozky(void *arg)
{
  MENU urceni_padu_predlozky = {
                                 {"[1] NOMINATIV",
                                  "[2] GENITIV",
                                  "[3] DATIV",
                                  "[4] AKUZATIV",
                                  "[5] VOKATIV",
                                  "[6] LOKAL",
                                  "[7] INSTRUMENTAL",
				  ""} ,
                                 {p_nominativ, p_genitiv, p_dativ, p_akuzativ,
                                  p_vokativ, p_lokal, p_instrumental,
                                  NULL} ,
                                 {'1', '2', '3', '4', '5', '6', '7',
                                  '\0'}
                               };
  P_MENU p_urceni_padu_predlozky = &urceni_padu_predlozky;

  /* nastaveni nepouzivanych vlastnosti */
  ((P_SLOVO) arg)->vlastnosti.pad = PADSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.rod = RODSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_jmena = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.tvar = TVARSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.osoba = OSOBASENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.cislo_slovesa = CISLOSENEPOUZIVA;
  ((P_SLOVO) arg)->vlastnosti.jmenny_rod = RODSENEPOUZIVA;

  /* nastaveni specifickych vlastnosti vlastnosti */
  printf("Urceni padu se, kterym se predlozka poji\n\n");
  vypis_menu(p_urceni_padu_predlozky);
  zpracuj_menu(p_urceni_padu_predlozky, arg);
}

  /*************************************************************
   *                                                           *
   * 2. Prace s vetnymi cleny - vytvoreni fronty vetnych clenu *
   *                                                           *
   *************************************************************/

//------------------------NACTI_FRONTU_VETNYCH_CLENU--------------------------
void nacti_frontu_vetnych_clenu(FRONTAVETNYCHCLENU *fvc, FRONTASLOV *fs, int limit)
  /* 1. do fvc nacte vetne cleny z fronty slov fs
   * 2. delka vetneho clenu je omezena paramtrem limit, standartne limit =
   *    = MAXDELKAVETNEHOCLENU = 40
   * 3. predpoklada uz na pevno urcene typy vetnych clenu (SAMOSTATNY,
   *    NESAMOSTATNY, NENI)
   */
{
  int i = 1;
  P_PFS p_pfs; /* pointer na prvek fronty slov */
  VETNYCLEN vc;

  /* 1. KROK - VYTVORENI SAMOSTATNYCH VETNYCH CLENU */

  for (p_pfs = fs->p_celo; p_pfs != fs->p_volny; p_pfs = p_pfs->p_dalsi) {

    if (p_pfs->slovo.typ_vetneho_clenu == SAMOSTATNY) {

      /* INICIALIZACE */

      /* prirazeni jmenovky a poradi do vetneho clenu */
      strcpy(vc.jmenovka, p_pfs->slovo.jmenovka);
      vc.poradi = i++; /* inkrementace pro dalsi pouziti */

      /* urceni druhu slova, ze ktereho clen pochazi + poradi jmenovky
       * tohoto slova
       */
      {
        int j;

        vc.druh_slova[0] = p_pfs->slovo.druh;
        vc.poradi_jmenovky_ve_vete[0] = p_pfs->slovo.poradi;

        for (j = 1; j < MAXPOCETJMENOVEKVEVC; ++j) {
          vc.druh_slova[j] = DRUHSLOVASENEPOUZIVA;
          vc.poradi_jmenovky_ve_vete[j] = 0;
        }
      }

      /* prvotni urceni urceni mozneho druhu vetneho clenu
       * zatim pouze na zaklade druhu slova a jeho vlastnosti
       */
      {
        int j = 0;

        switch (p_pfs->slovo.druh) {

          /* zajmeno */
          case ZAJMENO:

          /* podj */
          case PODJ:
            if (p_pfs->slovo.vlastnosti.pad == NOMINATIV)
              vc.druh[j++] = PODMET;
            else {
              vc.druh[j++] = PRIVLASTEK;
              vc.druh[j++] = PREDMET;
              vc.druh[j++] = PRISL_URCENI;
            }
          break;

          /* cislovka */
          case CISLOVKA:

          /* pridj */
          case PRIDJ:
            if (p_pfs->slovo.vlastnosti.pad == NOMINATIV)
              vc.druh[j++] = PODMET;
            else
              vc.druh[j++] = PRIVLASTEK;
          break;

          /* sloveso */
          case SLOVESO:
	    if (p_pfs->slovo.vlastnosti.tvar == URCITY)
              vc.druh[j++] = PRISUDEK;
            else {
              vc.druh[j++] = PODMET;
              vc.druh[j++] = PREDMET;
              vc.druh[j++] = PRISL_URCENI; /* "jel tam lyzovat" */
            }
	  break;

          /* prislovce */
          case PRISLOVCE:
            vc.druh[j++] = PRISL_URCENI;
            vc.druh[j++] = PRIVLASTEK; /* "cesta domu" */
          break;

          /* citoslovce */
          case CITOSLOVCE:
            vc.druh[j++] = PRISUDEK; /* "zaba zblunk do vody" */
          break;

          /* default */
          default:
            ;
          break;
        } /* konec switch (p_pfs->slovo.druh) */

        /* doplneni pole o neurcite hodnoty */
        for (; j < POCETDRUHUVETNYCHCLENU; ++j)
          vc.druh[j] = NEZNAMY;
      } /* konec bloku prvotniho urceni vetneho clenu */

      /* nadrizenost a podrizenost */
      vc.p_nadr = vc.p_podr = NULL;

      /* vlastnosti vetneho clenu */
      vc.vlastnosti.rozvity = NE;
      vc.vlastnosti.nekolikanasobny = NE;

      /* PRIDANI NOVEHO VETNEHO CLENU NA KONEC FRONTY */

      vloz_na_konec_fronty_vc(fvc, &vc);
    } /* zakonceni if (p_pfs->slovo.typ_vetneho_clenu == SAMOSTANY) */
  } /* konec for - konec 1. KROKU */

  /* 2. KROK - PRIDANI NESAMOSTATNYCH VETNYCH CLENU */
  /* v uvahu prichazi zvratna zajmena 'si' a 'se' + predlozky */

  for (p_pfs = fs->p_celo; p_pfs != fs->p_volny; p_pfs = p_pfs->p_dalsi) {

    if (p_pfs->slovo.typ_vetneho_clenu == NESAMOSTATNY) {
      switch (p_pfs->slovo.druh) {

        /* zajmeno */
	case ZAJMENO:
	  { /* hledam urcity tvar slovesa */
	    P_PFVC p_pfvc; /* pointer na prvek fronty vetnych clrnu */
	    P_PFS p_pfs_pom; /* pomocny pointer do fronty slov */

	    for (p_pfvc = fvc->p_celo; p_pfvc != fvc->p_volny; p_pfvc = p_pfvc->p_dalsi) {
	      /* najdu sloveso */
	      if (p_pfvc->vetnyclen.druh_slova[0] == SLOVESO) {
		/* potrebuji udaje o tvaru slovesa
		 * tj. udaje o prvku na pozici xxx ve fronte slov
		 */
		p_pfs_pom = get_prvek_z_fs_s_poradim(fs, p_pfvc->vetnyclen.poradi_jmenovky_ve_vete[0]);
		if (p_pfs_pom->slovo.vlastnosti.tvar == URCITY) {
		  /* predlozka sem patri */
		  char pomocna_jmenovka[MAXDELKAVETNEHOCLENU];
		  int j;

		  /* prohozeni jmenovky
		   * netestuji, zda delka jmnovky je delsi nez limit
		   */
		  strcpy(pomocna_jmenovka, p_pfvc->vetnyclen.jmenovka);
		  strcat(pomocna_jmenovka, " ");
		  strcat(pomocna_jmenovka, p_pfs->slovo.jmenovka);
		  strcpy(p_pfvc->vetnyclen.jmenovka, pomocna_jmenovka);

		  /* uprava druhu slova
		   * netestuji, zda pocet jmenovek je vesti nez
		   * MAXPOCETJMENOVEKVEVC
		   */
		  for (j = 0; (j < MAXPOCETJMENOVEKVEVC && p_pfvc->vetnyclen.druh_slova[j] != DRUHSLOVASENEPOUZIVA); ++j)
		    ;
		  p_pfvc->vetnyclen.druh_slova[j] = p_pfs->slovo.druh;
		  p_pfvc->vetnyclen.poradi_jmenovky_ve_vete[j] = p_pfs->slovo.poradi;

		  /* zmena vlastnosti vetneho clenu */
		  p_pfvc->vetnyclen.vlastnosti.rozvity = ANO;
		} /* konec if (p_pfs_pom->slovo.vlastnosti.pad == p_pfs->slovo.vlastnosti.predlozka)*/
	      } /* konec if (p_pfvc->vetnyclen.druh_slova[0] == PODJ) */
	    } /* konec for */
	  }
	break;

	/* predlozka */
	case PREDLOZKA:
	  { /* hledam nejblizsi (dalsi) vhodne podj */
	    P_PFVC p_pfvc; /* pointer na prvek fronty vetnych clrnu */
	    P_PFS p_pfs_pom; /* pomocny pointer do fronty slov */

	    for (p_pfvc = fvc->p_celo; p_pfvc != fvc->p_volny; p_pfvc = p_pfvc->p_dalsi) {
	      /* najdu podstatne jmeno */
	      if (p_pfvc->vetnyclen.druh_slova[0] == PODJ) {
		/* potrebuji udaje o padu jmena
		 * tj. udaje o prvku na pozici xxx ve fronte slov
		 */
		p_pfs_pom = get_prvek_z_fs_s_poradim(fs, p_pfvc->vetnyclen.poradi_jmenovky_ve_vete[0]);
		if (p_pfs_pom->slovo.vlastnosti.pad == p_pfs->slovo.vlastnosti.predlozka) {
		  /* predlozka sem patri */
		  char pomocna_jmenovka[MAXDELKAVETNEHOCLENU];
		  int j;

		  /* prohozeni jmenovky
		   * netestuji, zda delka jmnovky je delsi nez limit
		   */
		  strcpy(pomocna_jmenovka, p_pfs->slovo.jmenovka);
		  strcat(pomocna_jmenovka, " ");
		  strcat(pomocna_jmenovka, p_pfvc->vetnyclen.jmenovka);
		  strcpy(p_pfvc->vetnyclen.jmenovka, pomocna_jmenovka);

		  /* uprava druhu slova
		   * netestuji, zda pocet jmenovek je vesti nez
		   * MAXPOCETJMENOVEKVEVC
		   */
		  for (j = 0; (j < MAXPOCETJMENOVEKVEVC && p_pfvc->vetnyclen.druh_slova[j] != DRUHSLOVASENEPOUZIVA); ++j)
		    ;
		  p_pfvc->vetnyclen.druh_slova[j] = p_pfs->slovo.druh;
		  p_pfvc->vetnyclen.poradi_jmenovky_ve_vete[j] = p_pfs->slovo.poradi;

		  /* zmena vlastnosti vetneho clenu */
		  p_pfvc->vetnyclen.vlastnosti.rozvity = ANO;
		} /* konec if (p_pfs_pom->slovo.vlastnosti.pad == p_pfs->slovo.vlastnosti.predlozka)*/
	      } /* konec if (p_pfvc->vetnyclen.druh_slova[0] == PODJ) */
	    } /* konec for */
	  } /* konec bloku */
	break;

	/* default */
	default:
	  ;
	break;
      } /* konec switch (p_pfs->druh) */
    } /* konec if (p_pfs->slovo.typ_vetneho_clenu == NESAMOSTATNY) */
  } /* konec for - konec 2. KROKU */

  /* 3. KROK - vypsani vlastnosti vetnych clenu */

  {
    P_PFVC p_pfvc; /* pointer na prvek fronty vetnych clenu */

    for (p_pfvc = fvc->p_celo; p_pfvc != fvc->p_volny; p_pfvc = p_pfvc->p_dalsi) {
      putchar('\n');
      vypis_vlastnosti_vc(&(p_pfvc->vetnyclen));
      (void) getkey();
    }
  } /* konec treriho kroku */
}

//-------------------------VYPIS_VLASTNOSTI_VC--------------------------------
void vypis_vlastnosti_vc(P_VETNYCLEN p_vc)
{
  printf("jmenovka: %s\n"
	 "poradi: %d\n"
	 "druh: [0] %d [1] %d [2] %d [3] %d\n"
	 "druh_slova: [0] %d [1] %d [2] %d [3] %d\n"
	 "poradi_jmenovky_ve_vete: [0] %d [1] %d [2] %d [3] %d\n"
	 "nadr: %p\n"
         "podr: %p\n"
	 "vlastnosti.rozvity: %d\n"
	 "vlastnosti.nekolikanasobny: %d\n",
	 p_vc->jmenovka,
	 p_vc->poradi,
	 p_vc->druh[0], p_vc->druh[1], p_vc->druh[2], p_vc->druh[3],
	 p_vc->druh_slova[0], p_vc->druh_slova[1], p_vc->druh_slova[2], p_vc->druh_slova[3],
	 p_vc->poradi_jmenovky_ve_vete[0], p_vc->poradi_jmenovky_ve_vete[1], p_vc->poradi_jmenovky_ve_vete[2], p_vc->poradi_jmenovky_ve_vete[3],
	 p_vc->p_nadr,
	 p_vc->p_podr,
	 p_vc->vlastnosti.rozvity,
	 p_vc->vlastnosti.nekolikanasobny);
}

  /****************************************
   *                                      *
   * 3. Analyza vztahu mezi vetnymi cleny *
   *                                      *
   ****************************************/

//------------------ANALYZUJ_VZTAHY_MEZI_VETNYMI_CLENY------------------------
int analyzuj_vztahy_mezi_vetnymi_cleny(FRONTAVETNYCHCLENU *fvc, FRONTASLOV *fs)
  /* vraci 1, je-li vse OK
   * vraci nula, jestlize se mu nepodarilo urcit vsechny vztahy
   * vraci -1, nastala-li nejaka zasadni chyba (chybi podmet, prisudekm, ...
   * urcuje nadrizenost a podrizenost
   * predpoklada. ze vsechny vetne cleny jsou jiz urceny
   */

  /* nemenim vlastnosti na zaklade urceneho vetneho clenu (napr. najdu-li
   * mel bych zrusit veskere dalsi kandidaty)
   */

{
  P_PFVC prisudek;
  P_PFVC podmet;

  clrscr();

  /* hledam prisudek, mel by byt jednoznacny */
  if ((prisudek = hledej_prisudek(fvc, fs, fvc->p_celo)) != NULL) {
    printf("\n--------  Prisudek  --------\n\n");
    vypis_vlastnosti_vc(&(prisudek->vetnyclen));
  }
  else {
    printf("\nERROR: Vete chybi prisudek\n\n");
  }

  (void) getkey();

  /* po urceni prisudku bude i podmet jednoznacny */
  if ((podmet = hledej_podmet(fvc, fs, fvc->p_celo, prisudek)) != NULL) {
    printf("\n--------  Podmet  --------\n\n");
    vypis_vlastnosti_vc(&(podmet->vetnyclen));
  }
  else {
    printf("\nERROR: Vete chybi podmet\n\n");
  }

  (void) getkey();

  return(0);
}

//---------------------HLEDEJ_PRISUDEK----------------------------------------
P_PFVC hledej_prisudek(FRONTAVETNYCHCLENU *fvc, FRONTASLOV *fs, P_PFVC od_pozice)
  /* vraci pointer na prisudek, jinak NULL
   * prohledava fvc od pozice ukazatele od_pozice - na zacatku celo, potom
   * tma poslu vzdy od pozice neuspesneho nalezu
   */
{
  P_PFVC p_pfvc; /* pointer na frontu vetnych clenu */
  P_PFS p_pfs; /* pointer na frontu slov */

  for (p_pfvc = od_pozice; p_pfvc != fvc->p_volny; p_pfvc = p_pfvc->p_dalsi) {
    p_pfs = get_prvek_z_fs_s_poradim(fs, p_pfvc->vetnyclen.poradi_jmenovky_ve_vete[0]);
    if (p_pfs->slovo.druh == SLOVESO && p_pfs->slovo.vlastnosti.tvar == URCITY) {
      return(p_pfvc);
    }
  }
  return(NULL);
}

//----------------------HLEDEJ_PODMET-----------------------------------------
P_PFVC hledej_podmet(FRONTAVETNYCHCLENU *fvc, FRONTASLOV *fs, P_PFVC od_pozice, P_PFVC prisudek)
  /* vraci pointer na podmet, jinak NULL
   * prohledava fvc od pozice ukazatele od_pozice - na zacatku celo, potom
   * tma poslu vzdy od pozice neuspesneho nalezu
   */
{
  P_PFVC p_pfvc;
  P_PFS p_pfs1; /* udrzuje si udaje o slove, ktere tvori prisudek */
  P_PFS p_pfs2; /* udrzuje udaje o zakladnim clenu tvoricim podmet */

  p_pfs1 = get_prvek_z_fs_s_poradim(fs, prisudek->vetnyclen.poradi_jmenovky_ve_vete[0]);

  /* HLEDANI PODJ */

  for (p_pfvc = od_pozice; p_pfvc != fvc->p_volny; p_pfvc = p_pfvc->p_dalsi) {
    /* muze vetny clen byt podmetem? */
    int i;

    for (i = 0; i < POCETDRUHUVETNYCHCLENU; ++i) {
      if (p_pfvc->vetnyclen.druh[i] == PODMET) {
	p_pfs2 = get_prvek_z_fs_s_poradim(fs, p_pfvc->vetnyclen.poradi_jmenovky_ve_vete[0]);
	if (p_pfs2->slovo.druh == PODJ)
	  /* porovnani mluvnickych kategorii */
	  if (p_pfs2->slovo.vlastnosti.cislo_jmena == p_pfs1->slovo.vlastnosti.cislo_slovesa)
            if (p_pfs1->slovo.vlastnosti.jmenny_rod == RODSENEPOUZIVA)
              return(p_pfvc);
            else
              if (p_pfs1->slovo.vlastnosti.jmenny_rod == p_pfs2->slovo.vlastnosti.rod)
                return(p_pfvc);
      }
    }
  } /* konec prochazeni fvc */

  /* HLEDANI ZAJMENA */

  /* chybi */

  /* HLEDANI PRIDJ */

  /* chybi */

  return(NULL);
}