//=========================DOKUMENTACNI CAST==================================

  /*
   * MYVISION.CPP, verze 1.0 pro MS-DOS
   *
   * Usnadnuje praci s klavesnici, pomaha pri tvorbe menu
   *
   * Martin Slouf, 20.5.199
   *
   */

//========================POTREBNE INCLUDE SOUBORY============================

  /*
   * systemove .H soubory #include <stdio.h>
   *
   * vlastni .H soubory #include "vzor.h"
   *
   */

#include <stdio.h>
#include <conio.h>
#include <string.h>

#include "myvision.h"

//===================DEFINICE GLOBALNICH IMPORTOVANYCH OBJEKTU================

  //zadne by byt nemely - vse by melo byt v .H souborech

  /*
   * jde o importovane objekty (fce nebo promenne) - jiz musi byt v nejakem
   * modulu definovany (v casti globalnich definic)
   *
   * zde se objevi jako extern deklarace
   *
   */


//=================DEFINICE GLOBALNICH EXPORTOVANYCH PROMENNYCH===============

  /*
   * jde o globalni promenne, ktere maji byt sdileny s jinymi moduly, zde
   * nejsou definovany jako extern - jde o jejich "domaci" modul
   *
   * ve sdilenych modulech se objevi za pomoci .H souboru prislusejiciho
   * k tomuto modulu (v tomto .H souboru budou uvedeny jako extern deklarace)
   *
   */

void *argument1;
  /* pointer na typ void
   * pouziva se jako skutecny parametr k fcim nabidek, kde jim muze predat
   * najakou informaci
   * pochopitelne az po duslednem ! pretypovani !
   */

//=======================LOKALNI DEFINICE PRO TENTO MODUL=====================

  /*
   * lokalni definice pouze pro tento modul (soubor), pokud by tyto definice
   * byly prilis rozsahle -> specialni .H soubor
   *
   */

  /*
   * 1. symbolicke konstanty a makra s parametry
   *
   */

  /*
   * 2. typy - zasadne pomoci typedef
   *
   */

  /*
   * 3. promenne - jde o globalni promenne pro tento modul - v pametove tride
   *    static
   *
   */

  /*
   * 4. uplne funkcni prototypy lokalnich (=pro tento modul) funkci, tj.
   * v pametove tride static
   *
   */

  /*
   * 5. fce main - pokud jde o hlavni soubor projektu
   *
   */

//========================DEFINICE GLOBALNICH FUNKCI==========================

  /*
   * jde o funkce, ktere jsou exportem modulu, jejich uplne funkcni prototypy
   * jsou v prislusnem .H souboru (obdobne jako u globalnich promennych, ani
   * zde neni uvedena zadna pametova trida, ale v prislusnem .H souboru jsou
   * deklarovany jako extern)
   *
   */

  /*
   * 1. Cteni z klavesnice
   *
   * 2. Obsluha stisku klaves
   *
   * 3. Fce pro obsluhu menu
   *
   */

  /*************************
   *                       *
   * 1. Cteni z klavesnice *
   *                       *
   *************************/

//---------------------------GETKEY-------------------------------------------
int getkey(void)
  /* vraci stisknutou klavesu
   * reaguje ihned (neceka na stisk ENTERu)
   */
{
 int key;

 fflush(stdin); /* vycisteni bufferu */

 return(((key = getch()) == '\0') ? (getch() + 128) : key);
}

//---------------------------GETDEFINED---------------------------------------
int getdefined(const int s[], int *index)
  /* 1. vraci stisknutou klavesu - navratovy typ je int, protoze fce pracujici
   *    se znaky - getch(), getchar(), getc(), ... -  maji navratovy typ int
   * 2. v promenne index vraci index teto klavesy v poli
   * 3. ceka na stisk klavesy, ktera je ulozena v poli s[]
   * 4. K bodu 1.
   *    Chtel-li bych pracovat jen s typem char (tj. s[] by vypadalo char s[],
   *    mam dve moznosti (jinak to nefunguje - proc? - protoze porovnava
   *    nespravne byty vezme 1 prideleny charu a bez pretypovani vezme 1.
   *    prideleny intu - obdoba jako u EOF - viz UJC2 str 31):
   *    a) pretypovat v podmince promennou int c na (char) c
   *    b) vsechny navratove typy fci opravit na char, pole s[] taky, navic
   *       bych vsude musel cist do promennych typu char (coz by se
   *       neslucovalo s fcemi getchar(), getch(), getc(), ...)
   */
{
  int c; /* znak do ktereho ctu */

  do {
    c = getkey();
    for(*index = 0; (*(s + *index) != '\0' && *(s + *index) != /* (char) */ c); ++(*index))
      ;
  } while (*(s + *index) == '\0');

  return(c);
}

  /*****************************************
   *                                       *
   * 2. Obsluha stisku klaves -> STISK_key *
   *                                       *
   *****************************************/

//----------------------------STISK_TAB---------------------------------------
void stisk_TAB(void *arg)
{
  printf("stisk_TAB\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_ESC---------------------------------------
void stisk_ESC(void *arg)
{
  printf("stisk_ESC\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_ENTER-------------------------------------
void stisk_ENTER(void *arg)
{
  printf("stisk_ENTER\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_BACK--------------------------------------
void stisk_BACK(void *arg)
{
  printf("stisk_BACK\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F1----------------------------------------
void stisk_F1(void *arg)
{
  printf("stisk_F1\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F2----------------------------------------
void stisk_F2(void *arg)
{
  printf("stisk_F2\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F3----------------------------------------
void stisk_F3(void *arg)
{
  printf("stisk_F3\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F4----------------------------------------
void stisk_F4(void *arg)
{
  printf("stisk_F4\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F5----------------------------------------
void stisk_F5(void *arg)
{
  printf("stisk_F5\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F6----------------------------------------
void stisk_F6(void *arg)
{
  printf("stisk_F6\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F7----------------------------------------
void stisk_F7(void *arg)
{
  printf("stisk_F7\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F8----------------------------------------
void stisk_F8(void *arg)
{
  printf("stisk_F8\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F9----------------------------------------
void stisk_F9(void *arg)
{
  printf("stisk_F9\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F10---------------------------------------
void stisk_F10(void *arg)
{
  printf("stisk_F10\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F11---------------------------------------
void stisk_F11(void *arg)
{
  printf("stisk_F11\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_F12---------------------------------------
void stisk_F12(void *arg)
{
  printf("stisk_F12\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_INS---------------------------------------
void stisk_INS(void *arg)
{
  printf("stisk_INS\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_DEL---------------------------------------
void stisk_DEL(void *arg)
{
  printf("stisk_DEL\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_HOME--------------------------------------
void stisk_HOME(void *arg)
{
  printf("stisk_HOME\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_END---------------------------------------
void stisk_END(void *arg)
{
  printf("stisk_END\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_PGUP--------------------------------------
void stisk_PGUP(void *arg)
{
  printf("stisk_PGUP\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_PGDN--------------------------------------
void stisk_PGDN(void *arg)
{
  printf("stisk_PGDN\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_UP----------------------------------------
void stisk_UP(void *arg)
{
  printf("stisk_UP\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_DOWN--------------------------------------
void stisk_DOWN(void *arg)
{
  printf("stisk_DOWN\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_LEFT--------------------------------------
void stisk_LEFT(void *arg)
{
  printf("stisk_LEFT\nadresa argumentu: %p\n", arg);
}

//----------------------------STISK_RIGHT-------------------------------------
void stisk_RIGHT(void *arg)
{
  printf("stisk_RIGHT\nadresa argumentu: %p\n", arg);
}

  /***************************
   *                         *
   * 3. Fce pro obsluhu menu *
   *                         *
   ***************************/

//---------------------------VYPIS_MENU---------------------------------------
void vypis_menu(P_MENU menu)
{
  int i;

  _setcursortype(_NOCURSOR); /* vypnuti kurzoru */

  for (i = 0; (strcmp(menu->polozky[i], "") != 0); ++i)
    printf("%s\n", menu->polozky[i]);
}

//--------------------------ZPRACUJ_MENU--------------------------------------
void zpracuj_menu(P_MENU menu, void *arg)
{
  int index;
  char key;

  key = getdefined(menu->zkratky, &index);

  /* oznaceni volby */
  printf("\n"
         "\tVolba: %s\n"
         "\n", menu->polozky[index]);

  /* volani obsluzne fce */
  menu->fce[index](arg);
    /* proc nelze : (*menu).(*(fce + i))(); (podle K&R)
     * nebo: menu->(*(fce +i))(); (podle ANSI C)
     */
}

//========================DEFINICE LOKALNICH FUNKCI===========================

  /*
   * definice funkci pro tento modul (pametova trida static)
   *
   * jejich funkcni prototypy - viz vyse
   *
   */