#ifndef _MYVISION_H
#define _MYVISION_H

//==========================DOKUMENTACNI CAST=================================

  /*
   * MYVISION.H, verze 1.0 pro MS-DOS
   *
   * Hlavickovy soubor k modulu _MYVISION.CPP, obsahuje deklarace nabidek
   * (menu) a operaci, ktere jsou nad nim provadeny + par uzitecnych fci pri
   * praci s klavesnici
   *
   * Martin Slouf, 1.6.1999
   *
   */

//========================DEFINICE MAKER=====================================

/* konstanty klaves */
#define BACK    8
#define TAB     9
#define ENTER  13
#define ESC    27

#define F1    187
#define F2    188
#define F3    189
#define F4    190
#define F5    191
#define F6    192
#define F7    193
#define F8    194
#define F9    195
#define F10   196
#define F11   261
#define F12   262

#define INS   210
#define DEL   211
#define HOME  199
#define END   207
#define PGUP  201
#define PGDN  209

#define UP    200
#define DOWN  208
#define LEFT  203
#define RIGHT 205

#define MAXMENU 15
  /* maximalni pocet polozek v menu je MAXMENU - 1
   * posledni polozka (na pozici MAXMENU) musi byt prazdny retez ""
   * obdobne posledni zkratkova klavesa musi byt '\0'
   * a posledni ukazatel na fci by mel byt NULL
   * pouzito v deklaraci typu MENU
   */

//========================DEFINICE GLOBALNICH TYPU============================

/* ------------------------------TYP MENU---------------------------------- */

typedef void (*P_FV)(void *argument);
  /* pointer na fci vracejici void a jednim argumentem - pointerem na void
   * typ pro procedury obsluhujici polozky menu
   */

typedef P_FV *P_P_FV;
  /* pointer na pointer na fci vracejici void
   * uziva se k definici dynamickeho pole pointeru na fce - tj. dynamicke
   * nabidky
   */

/* TYP MENU */
typedef struct menu {
  char *polozky[MAXMENU];
  P_FV fce[MAXMENU];
  int zkratky[MAXMENU];
} MENU, *P_MENU;

//==========DEKLARACE GLOBALNICH PROMENNYCH PRISLUSNEHO .CPP MODULU===========

extern void *argument1;
  /* pointer na typ void
   * pouziva se jako skutecny parametr k fcim nabidek, kde jim muze predat
   * najakou informaci (pochopitelne az po duslednem pretypovani!)
   * nemusi pochopitelne predat zadnou informaci
   */

//===============UPLNE FUNKCNI PROTOTYPY PRISLUSNEHO .CPP MODULU==============

/* 1. CTENI Z KLAVESNICE */
extern int getkey(void);
  /* vraci znak ze stdin, vcetne funkcnich klaves */
extern int getdefined(const int s[], int *index);
  /* 1. ceka na stisk klavesy, ktera je ulozena v poli s[]
   * 2. vraci stisknutou klavesu - navratovy typ je int
   * 3. v promenne index vraci index teto klavesy v poli
   */

/* 2. FCE PRO STISK KLAVES */
extern void stisk_TAB(void *arg);
extern void stisk_ESC(void *arg);
extern void stisk_ENTER(void *arg);
extern void stisk_BACK(void *arg);
extern void stisk_F1(void *arg);
extern void stisk_F2(void *arg);
extern void stisk_F3(void *arg);
extern void stisk_F4(void *arg);
extern void stisk_F5(void *arg);
extern void stisk_F6(void *arg);
extern void stisk_F7(void *arg);
extern void stisk_F8(void *arg);
extern void stisk_F9(void *arg);
extern void stisk_F10(void *arg);
extern void stisk_F11(void *arg);
extern void stisk_F12(void *arg);
extern void stisk_INS(void *arg);
extern void stisk_DEL(void *arg);
extern void stisk_HOME(void *arg);
extern void stisk_END(void *arg);
extern void stisk_PGUP(void *arg);
extern void stisk_PGDN(void *arg);
extern void stisk_UP(void *arg);
extern void stisk_DOWN(void *arg);
extern void stisk_LEFT(void *arg);
extern void stisk_RIGHT(void *arg);

/* 3. FCE PRO OBSLUHU MENU */
extern void vypis_menu(P_MENU menu);
extern void zpracuj_menu(P_MENU menu, void *arg);

#endif